import {
  VuexModule,
  Module,
  getModule,
  Mutation,
  Action
} from "vuex-module-decorators";
import store from "../index";
import { getMenu } from "@/api/menu";
import i18n from "@/lang";
import vue from "vue";
@Module({ dynamic: true, store, name: "menu", namespaced: true })
class Menu extends VuexModule {
  private data: {
    [index: string]: IMenu[];
  } = {};
  @Action
  public async getList() {
    if (this.list.length) return;
    const list = await getMenu();
    this.setList(list);
  }
  @Mutation
  private setList(list: IMenu[]) {
    vue.set(this.data, i18n.locale, list);
  }
  get list() {
    return this.data[i18n.locale] || [];
  }
  get pList() {
    return this.list.filter(({ pId }) => !pId);
  }

  get subList() {
    return (pid: number) => this.list.filter(({ pId }) => pId === pid);
  }

  get info() {
    return (id: number) => this.list.find(x => x.id === id);
  }
}
export default getModule(Menu);
